# encoding: utf-8
module FeduxOrgStdlib
  module Colors
    # HTML color
    #
    # Helps you to check if given string is a valid html color
    class HtmlColor
      # @param [String] color
      #   string in the html color format
      def initialize(color)
        @color           = color
        @validator_regex = /^#[a-f0-9]{6}$/
      end

      # Is color valid?
      # @return [true,false] color string is valid
      def valid?
        # rubocop:disable Style/CaseEquality
        @validator_regex === @color
        # rubocop:enable Style/CaseEquality
      end
    end
  end
end
