# encoding: utf-8
require 'fedux_org_stdlib/core_ext/array/list'

# Hash
class Hash
  # Convert Hash to list
  #
  # For more examples see 'fedux_org_stdlib/core_ext/array/list'
  #
  # @example Change separator for key and value
  #
  #   input = {
  #     opt1: 'asdf',
  #     opt2: 'asdf'
  #   }
  #
  #   input.to_list(format: "%s | %s")
  #   => "opt1 | asdf", "opt2 | asdf"
  #
  # @example Change separator between key/value-pairs
  #
  #   input = {
  #     opt1: 'asdf',
  #     opt2: 'asdf'
  #   }
  #
  #   input.to_list(format: "%s | %s")
  #   => "opt1 | asdf", "opt2 | asdf"
  #
  # @example Change character around key/value-pair
  #
  #   input = {
  #     opt1: 'asdf',
  #     opt2: 'asdf'
  #   }
  #
  #   input.to_list(around: "'")
  #   => 'opt1: asdf', 'opt2: asdf'
  #
  # @return [String]
  #   A string representation of hash as list
  def to_list(format: '%s: %s', **args)
    map { |key, value| format(format, key, value) }.to_list(**args)
  end
end
