# encoding: utf-8
require 'shellwords'

# Shellwords
module Shellwords
  class << self
    # Clean string based shell pattern
    #
    # @param [String] string
    #   The string which should be clean up
    #
    # @return [String]
    #   Every character which needs to be escape in a shell has been removed
    def shellclean(string)
      shellescape(string).gsub(/\\./, '')
    end
    alias_method :clean, :shellclean
  end
end
