# encoding: utf-8
require 'fedux_org_stdlib/rake/task'

module FeduxOrgStdlib
  module Rake
    # Sub Task
    #
    # This class can be used to call other defined rake-tasks
    #
    # @see Rakefile
    class SubTask < Task
      # @!attribute [r] command
      #   The command to be executed
      attr_reader :sub_tasks

      # Create a new sub task task
      #
      # @param [Array] sub_tasks
      #   A list of sub tasks, e.g. 'namespace1:task1', 'task2'
      def initialize(
        sub_tasks:,
        **args
      )
        super(**args)

        @sub_tasks = Array(sub_tasks)
      end

      # @private
      def run_task(_verbose)
        sub_tasks.each { |t| ::Rake::Task[t].invoke }
      end
    end
  end
end
