# encoding: utf-8
require 'fedux_org_stdlib/rake/exceptions'

module FeduxOrgStdlib
  module Roles
    # Versionable
    module Versionable
      def version_file(working_directory = Dir.getwd)
        paths = []
        paths << File.join(working_directory, 'lib', '**', 'version.rb')

        file = Dir.glob(paths.shift).first while !paths.blank? && file.blank?

        fail FeduxOrgStdlib::Rake::Exceptions::VersionFileNotFound, JSON.dump(message: 'Cannot find version file') unless file

        file
      end
    end
  end
end
