# encoding: utf-8
module FeduxOrgStdlib
  class TemplateDirectory
    module Exceptions
      # Found config file is not readable
      class TemplateDirectoryNotReadable < StandardError; end

      # No allowed config file could be found
      class NoTemplateDirectoryFound < StandardError; end

      # If no module is given on class
      class NamespaceIsMissing < StandardError; end

      # If no class name is present
      class ClassNameIsMissing < StandardError; end

      # If one tries to define an option name which is forbbiden
      class OptionNameForbidden < StandardError; end
    end
  end
end
