# encoding: utf-8
require 'json'
require 'fedux_org_stdlib/version_management/exceptions'

module FeduxOrgStdlib
  # Version management
  module VersionManagement
    # Ruby version file parser
    class RubygemVersionFileParser
      attr_reader :version, :modules

      def parse(file)
        data = File.read(file)

        @version = data.match(/(?:VERSION|Version)\s+=\s+["']([^'"]+)["']/) { Regexp.last_match[1] }
        @modules = data.scan(/^\s*module\s+([A-Z][A-Za-z0-9]+(?:::[A-Z][A-Z0-9a-z]+)*)$/x).flatten

        fail Exceptions::VersionFileInvalid, JSON.dump(file: file) if version.blank?
      end
    end
  end
end
