#!/usr/bin/env rake

$LOAD_PATH << File.expand_path('../lib', __FILE__)

require 'fedux_org_stdlib/rake_tasks'
require 'fedux_org_stdlib/rake_tasks/webserver'

desc 'Show help for rake'
task :default do
  sh 'bundle exec rake -T'
end

desc 'Run test suite'
task test: ['test:rubocop', 'test:rspec']

namespace :test do
  desc 'Test with coveralls'
  task coveralls: ['test', 'coveralls:push']

  require 'rubocop/rake_task'
  RuboCop::RakeTask.new

  desc 'Run rspec'
  task :rspec do
    sh 'bundle exec rspec'
  end
end
